/* Agent Tcl
   Bob Gray
   23 August 1995

   parse.h

   This file defines the parsing routines.

   Copyright (c) 1995, Robert S. Gray Dartmouth College

   See the file "agent.terms" for information on usage and redistribution
   of this file and for a DISCLAIMER OF ALL WARRANTIES.
*/

#ifndef _PARSE_H
#define _PARSE_H

#include <stdio.h>

class PARSE
{
   FILE *fp;        /* file that is being parsed */
   int ch;          /* current character         */
   int size;        /* maximum word length       */
   char *buffer;    /* buffer to hold a word     */
   int line;        /* line number               */

      /* skip over a comment */

   void skip_comment (void);

  public:

      /* constructor */

    PARSE (FILE *fp, int size);

      /* the next word */

    int next_word (char **buffer_ptr);

      /* get the line number */

    inline int current_line (void) {return line; };
};

#endif
